
Core - Bug # 30643

Status: Resolved Priority: Should have
Author: Steffen Gebert Category: Workspaces
Created: 2011-10-07 Assigned To:
Updated: 2015-06-01 Due date:
TYPO3 Version: 4.6
PHP Version:
Complexity:
Is Regression: No
Sprint Focus:
Subject: Fatal Error in Workspaces preview
Description

When opening the horizontal/vertical WS previews, I get the following error:

Fatal error: Call to a member function getSessionData() on a non-object in
typo3/sysext/workspaces/Classes/Service/Fehooks.php on line 50
Call Stack
#    Time    Memory    Function    Location
1    0.0001    642312    {main}( )    ../profile.php:0
2    0.0050    905464    require( '/opt/local/www/master/typo3_src/index.php' )    ../profile.php:4
3    0.0064    1108056    require( '/opt/local/www/master/typo3_src/typo3/sysext/cms/tslib/index_ts.php' )    ../index.php:78
4    1.3018    25442840    tslib_fe->hook_eofe( )    ../index_ts.php:500
5    1.3018    25444312    t3lib_div::callUserFunction( )    ../class.tslib_fe.php:3818
6    1.3023    25458696    call_user_func_array ( )    ../class.t3lib_div.php:4677
7    1.3023    25458840    Tx_Workspaces_Service_Fehooks->hook_eofe( )    ../class.t3lib_div.php:4677

The line causing this error is
$GLOBALS['BE_USER']->getSessionData('workspaces.backend_domain')

I am still logged in in the backend. The slider works. Working on master with Introduction Package.

Related issues:
related to Core - Task # 67224: Restructure list of conditions of #30643 Resolved 2015-06-01

Associated revisions
Revision fc3a6e70 - 2015-06-01 14:31 - Peter Niederlag

[BUGFIX] dont set fePreview=2 with ADMCMD_noBeUser

The workspace preview adds the GET parameter ADMCMD_noBeUser
when requesting the frame for live preview.

$GLOBALS[BE_USER] is unset in index_ts.php when seeing ADMCMD_noBeUser.

In TypoScriptFrontendController fePreview=2 must not be set when
ADMCMD_noBeUser parameter is present to prevent fatal errors on
calling methods on a non-existent $GLOBALS[BE_USER]
Releases: master, 6.2
Resolves: #30643
Change-Id: Idff7febcaaa8b87bd65a993b1860ad378e09b22f
Reviewed-on: http://review.typo3.org/27834
Reviewed-by: Lorenz Ulrich <lorenz.ulrich@visol.ch>
Tested-by: Lorenz Ulrich <lorenz.ulrich@visol.ch>
Reviewed-by: Markus Bucher <markusbucher@gmx.de>
Tested-by: Markus Bucher <markusbucher@gmx.de>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>

Revision 57860a20 - 2015-06-01 14:42 - Peter Niederlag

[BUGFIX] dont set fePreview=2 with ADMCMD_noBeUser

The workspace preview adds the GET parameter ADMCMD_noBeUser
when requesting the frame for live preview.

$GLOBALS[BE_USER] is unset in index_ts.php when seeing ADMCMD_noBeUser.

In TypoScriptFrontendController fePreview=2 must not be set when
ADMCMD_noBeUser parameter is present to prevent fatal errors on
calling methods on a non-existent $GLOBALS[BE_USER]

Releases: master, 6.2
Resolves: #30643
Change-Id: Idff7febcaaa8b87bd65a993b1860ad378e09b22f
Reviewed-on: http://review.typo3.org/39860
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>

History
#1 - 2011-10-07 23:49 - Steffen Gebert

P.S: I get this error in the right/bottom frame of the WS preview.

#2 - 2011-10-19 23:23 - Tolleiv Nietsch
- Status changed from New to Needs Feedback

Hm maybe a plugin which influences the BE_USER ?

#3 - 2011-10-19 23:38 - Steffen Gebert

Well.. looks like it's now working. Dunno what was wrong.

#4 - 2011-11-21 00:53 - Stefan Neufeind
Steffen, any idea what might have gone wrong or what we could take a look at? Otherwise I'd suggest to close this bug.

#5 - 2011-11-21 19:00 - Steffen Gebert

I guess it can be closed. It did not occur anymore..

#6 - 2011-11-22 10:15 - Stefan Neufeind
- Status changed from Needs Feedback to Closed

#7 - 2012-03-05 02:27 - Christian Lerrahn

I'd like to re-open this because I got the same(?) error in 4.5.11.

While I cannot reproduce the problem on another site, here is what I have to do to reproduce it on the site where it occurred.

1. Log in to an account which only has access to a draft workspace.
2. Change the title of a shortcut page.
3. Preview the page.

The line
Fatal error: Call to a member function getSessionData() on a non-object in
/foo/bar/typo3_src-4.5.11/typo3/sysext/workspaces/Classes/Service/Fehooks.php on line 44
will appear instead of the draft preview on any visual preview (slider or splits).

I'm not sure which one of the details above play a role. The site also uses CoolURI which I wouldn't expect to play a role.

#8 - 2012-05-23 10:29 - Juergen Kussmann

Christian Lerrahn wrote:

I'd like to re-open this because I got the same(?) error in 4.5.11.

I also got this error-message in my PHP-logfile in 4.5.14. But i can't reproduce it :-(

#9 - 2012-08-09 10:28 - Luc Muller

Hi Guys

Anyone has a hint on this problem ?

I got the same problem using 4.5.11

By my side it occurs when I try to preview a tt_news record in workspace.

Here are some hint on my configuration.

Got a Workspace that give the user only access to a sysfolder "Articles". and a tt_news single page to preview articles
Got tt_news preview properly configured (tx_ttnews.singlePid = 13 ) in TSConfig
The user edit some article and then click save and preview.

Thus resulting in the php error declared above.

I'm thinking of an access problem to something but don't know where to look at... everything seems to be properly configured.

#10 - 2012-12-17 01:08 - Christian Lerrahn

I have encountered this problem again on 4.5.19. The object $GLOBALS['BE_USER'] is NULL if the backend user is currently set to preview. If you
switch to live workspace in the backend, so can preview the drft workspace without any issue.

#11 - 2012-12-18 20:12 - Urs Braem

I have a very similar issue in TYPO3 6.0.0

Fatal error: Call to a member function getSessionData() on a non-object in
/home/xxx/public_html/gov/typo3_src-6.0.0/typo3/sysext/workspaces/Classes/Hook/TypoScriptFrontendControllerHook.php on line 49

I am viewing as admin user.

No difference if I'm in the live or draft workspace

EDIT: I'm using the government package as downloaded from typo3.org, out of the box

#12 - 2013-12-10 00:57 - Michael Stucki
- Category changed from Bugs to Workspaces

#13 - 2013-12-10 01:01 - Michael Stucki
- Project changed from Workspaces & Versioning to Core
- Category changed from Workspaces to Workspaces

#14 - 2014-02-19 16:58 - Peter Niederlag
- Is Regression set to No

This problem is only uncovered when the user has clicked the link that is generated by "generate workspace preview link".

TYPO3\CMS\Workspaces\Controller/PreviewController

    -  PreviewController adds &ADMCMD_noBeUser=1 to the url to be called for the live version
    -  index_ts.php unsets $GLOBALS['BE_USER'] when seeing ADMCMD_noBeUser=1
Calling the "generate workspace preview link" 
    -  the preview link has ADMCMD_prev=#HASH#
    -  TYPO3\CMS\Version\Hook\PreviewHook checks for ADMCMD_prev and sets a cookie that effectivly makes the workspace preview persistent for
the session

Regular Frontend url's now have (persistent) workspace preview enabled

    -  TSFE->fePreview=2 is set
    -  TYPO3\CMS\Workspaces\Hook\TypoScriptFrontendControllerHook pops in due to TSFE->fePreview=2 and tries to access
$GLOBALS['BE_USER'] 
    -  fatal error

#15 - 2014-02-25 12:06 - Gerrit Code Review
- Status changed from Closed to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27834

#16 - 2014-02-26 10:48 - Thomas Sperling

I get a similiar error, but in typo3/sysext/workspaces/Classes/Hook/TypoScriptFrontendControllerHook.php on line 49.
This patch doesn't solve it for me. I think the Problem is that in the IFrame document.domain is not set. Is this problem related or is it a different
problem?

#17 - 2014-03-07 19:31 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27834

#18 - 2014-09-16 15:26 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27834

#19 - 2014-09-24 18:18 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/27834

#20 - 2015-01-23 11:33 - Mathias Schreiber
- Target version set to 7.5

#21 - 2015-06-01 14:31 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39860

#22 - 2015-06-01 15:00 - Peter Niederlag
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:fc3a6e70da09d8113101dff5091c7a2875c8aa9b.
